﻿local L = AceLibrary("AceLocale-2.2"):new("Automaton_Mailer")
Automaton_Mailer = Automaton:NewModule("Mailer", "AceHook-2.1", "AceEvent-2.0", "AceConsole-2.0", "AceDebug-2.0")

L:RegisterTranslations("enUS", function() return {
	["Mailer"] = true,
	["Options for easy mailing."] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Mailer"] = "수취인",
	["Options for easy mailing."] = "쉬운 우송을 위한 옵션을 설정합니다.",
} end)

L:RegisterTranslations("esES", function() return {
	["Mailer"] = "Correo",
	["Options for easy mailing."] = "Opciones para facilitar el env\195\173o de cartas",
} end)

Automaton.options.args.mailer = {
	type = 'toggle',
	name = L["Mailer"],
	desc = L["Options for easy mailing."],
	get = function() return Automaton:IsModuleActive("Mailer") end,
	set = function(v) Automaton:ToggleModuleActive("Mailer", v) end,
}

function Automaton_Mailer:OnInitialize()
	self.db = Automaton:AcquireDBNamespace("mailer")
	Automaton:RegisterDefaults('mailer', 'profile', {
		lastSent = ""
	})
end

function Automaton_Mailer:OnEnable()
	self:SecureHook("SendMail")
	self:RegisterEvent("MAIL_SHOW")
	self:RegisterEvent("MAIL_CLOSED")
	self:RegisterEvent("MAIL_SEND_SUCCESS")
end

function Automaton_Mailer:MAIL_SEND_SUCCESS()
	SendMailNameEditBox:SetText(self.db.profile.lastSent)
end

function Automaton_Mailer:SendMail(recipient)
	if recipient then
		self.db.profile.lastSent = recipient
	end
end

function Automaton_Mailer:MAIL_SHOW()
	self:SecureHook("ContainerFrameItemButton_OnModifiedClick")
end

function Automaton_Mailer:MAIL_CLOSED()
	self:Unhook("ContainerFrameItemButton_OnModifiedClick")
end

function Automaton_Mailer:ContainerFrameItemButton_OnModifiedClick(button)
	if button == "RightButton" and IsAltKeyDown() then
		PickupContainerItem(this:GetParent():GetID(), this:GetID())
		ClickSendMailItemButton()
		SendMailFrame_SendMail()
	end
end